﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Forms;
using Buddy.BehaviorTree;
using Buddy.Common;
using Buddy.Common.Plugins;
using Buddy.Swtor;
using Action = System.Action;

namespace Buddywing.Plugins
{
    class AutoSkip : IPlugin
    {
        #region Implementation of IEquatable<IPlugin>

        /// <summary>
        /// Indicates whether the current object is equal to another object of the same type.
        /// </summary>
        /// <returns>
        /// true if the current object is equal to the <paramref name="other"/> parameter; otherwise, false.
        /// </returns>
        /// <param name="other">An object to compare with this object.</param>
        public bool Equals(IPlugin other)
        {
            return other.Name == Name;
        }

        #endregion

        #region Implementation of IPlugin

        public string Author
        {
            get { return "Nesox"; }
        }

        public Version Version
        {
            get { return new Version(1, 0, 0); }
        }

        public string Name
        {
            get { return "AutoSkip"; }
        }

        public string Description
        {
            get { return "Let's kick auto skip conversations because he's a tard."; }
        }

        public Window DisplayWindow
        {
            get { return null; }
        }

        /// <summary> Executes the pulse action. This is called every "tick" of the bot. </summary>
        public void OnPulse()
        {
                
        }

        public Buddy.Swtor.Objects.TorPlaceable Chest { get { return ObjectManager.GetObjects<Buddy.Swtor.Objects.TorPlaceable>().FirstOrDefault(o => o.Name.Contains("Chest") && o.Distance <= 4f); } }

        /// <summary> Executes the initialize action. This is called at initial bot startup. (When the bot itself is started, not when Start() is called) </summary>
        public void OnInitialize()
        {
            Hotkeys.RegisterHotkey("Skip Conversation Light",
                                   () => OracleManager.SetConversationSkip(ConversationSkip.LightAutoSkip),
                                   Keys.R);

            Hotkeys.RegisterHotkey("Skip Conversation Dark",
                                   () => OracleManager.SetConversationSkip(ConversationSkip.DarkAutoSkip), 
                                   Keys.T);

            Hotkeys.RegisterHotkey("Skip Conversation Dark",
                                   () => OracleManager.SetConversationSkip(ConversationSkip.Normal),
                                   Keys.Y);
        }

        /// <summary> Executes the shutdown action. This is called when the bot is shutting down. (Not when Stop() is called) </summary>
        public void OnShutdown()
        {
        }

        /// <summary> Executes the enabled action. This is called when the user has enabled this specific plugin via the GUI. </summary>
        public void OnEnabled()
        {
        }

        /// <summary> Executes the disabled action. This is called whent he user has disabled this specific plugin via the GUI. </summary>
        public void OnDisabled()
        {
        }

        #endregion
    }
}
